--****************************************************************************
--******************************BONUS GAME 1**********************************
--****************************************************************************

function bg1saveHighscore()
	file = io.open("bg1hsf", "w")
	if file then
		for i = 1, 5 do
			file:write(bg1highscores[i][1]," ")
			file:write(bg1highscores[i][2]," ")
			file:write(bg1highscores[i][3]," ")
			file:write(bg1highscores[i][4]," ")
		end
		file:close()
	end
end
 
function bg1loadHighscore()
	file = io.open("bg1hsf", "r")
	if file then
		for i=1, 5 do
			bg1highscores[i][1] = file:read(3)
			bg1highscores[i][2] = file:read("*n")
			bg1highscores[i][3] = file:read("*n")
			bg1highscores[i][4] = file:read("*n")
			local dump = file:read(1)
		end
		file:close()
		dump = null
	end
end

function loadmg1intro()
	fadein(loadscreen, 30, 0)
	mg1 = Image.load("images/bonusgame1/mg1.png")
	mg2 = Image.load("images/bonusgame1/mg2.png")
	mg3 = Image.load("images/bonusgame1/mg3.png")
	mg4 = Image.load("images/bonusgame1/mg4.png")
	mg5 = Image.load("images/bonusgame1/mg5.png")
	mg6 = Image.load("images/bonusgame1/mg6.png")
	mg7 = Image.load("images/bonusgame1/mg7.png")
	fadeout(loadscreen, 30, 0)
end

function unloadmg1intro()
	mg1 = null
	mg2 = null
	mg3 = null
	mg4 = null
	mg5 = null
	mg6 = null
	mg7 = null
	collectgarbage()
end

function mg1intro()
	skip = 0
	loadmg1intro()
	Music.playFile("sounds/d0xeh.mod", true )

	fadein(mg1, 15, skip)
	movieskip(skip, 180)
	fadeout(mg1, 15, skip)

	fadein(mg2, 15, skip)
	movieskip(skip, 180)
	fadeout(mg2, 15, skip)

	fadein(mg3, 15, skip)
	movieskip(skip, 180)
	fadeout(mg3, 15, skip)

	fadein(mg4, 15, skip)
	movieskip(skip, 180)
	fadeout(mg4, 15, skip)

	fadein(mg5, 15, skip)
	movieskip(skip, 180)
	fadeout(mg5, 15, skip)

	fadein(mg6, 15, skip)
	movieskip(skip, 180)
	fadeout(mg6, 15, skip)

	fadein(mg7, 15, skip)
	movieskip(skip, 180)
	fadeout(mg7, 15, skip)

	musicfadeout()
	Music.stop()
	Music.volume(gamevolume)
	unloadmg1intro()
end

function loadgraphics()
	fadein(loadscreen, 30, 0)
	block_h = Sound.load("sounds/block_h.wav")
	flap = Sound.load("sounds/flap.wav")
	block = Image.load("images/blocks/block70x20.png")
	flier1 = Image.load("images/bonusgame1/flier1.png")
	flier2 = Image.load("images/bonusgame1/flier2.png")
	flier3 = Image.load("images/bonusgame1/flier3.png")
	tail = Image.load("images/bonusgame1/kitetail.png")
	fd1 = Image.load("images/bonusgame1/fd1.png")
	fd2 = Image.load("images/bonusgame1/fd2.png")
	obstacle1 = Image.load("images/bonusgame1/balloon.png")
	obstacle2 = Image.load("images/bonusgame1/kite.png")
	timer = Image.load("images/bonusgame1/stattimer.png")
	exp1 = Image.load("images/bosses/exp1.png")
	exp2 = Image.load("images/bosses/exp2.png")
	exp3 = Image.load("images/bosses/exp3.png")
	b1bg = Image.load("images/bonusgame1/bg.png")
	option = Image.load("images/bonusgame1/xo.png")
	b1scorebg = Image.load("images/bonusgame1/b1scorebg.png")
	fg1 = Image.load("images/bonusgame1/fg1.png")
	fg2 = Image.load("images/bonusgame1/fg2.png")
	bg1hs = Image.load("images/score/bg1hs.png")
	fadeout(loadscreen, 30, 0)
end

function unloadgraphics()
	block_h = null
	flap = null
	block = null
	flier1 = null
	flier2 = null
	flier3 = null
	tail = null
	fd1 = null
	fd2 = null
	obstacle1 = null
	obstacle2 = null
	timer = null
	exp1 = null
	exp2 = null
	exp3 = null
	bg = null
	option = null
	b1scorebg = null
	fg1 = null
	fg2 = null
	obstacle_list = null
	bg1hs = null
	uninitGameEnvironment()
	collectgarbage()
end

function initGameEnvironment()
	displayTime = 0
	playing = 0
	glider = {x = 20, y = 50, w = 60, h = 80, cx = 0}
	obstacle_list = {}
	block_width = 70
	level_track = 0
	scroll_speed = 5
	obstacle_speed = 3
	bg1difficulty = 300
	gravity = 0
	gravity_delay_max = 5
	gravity_delay = gravity_delay_max
	obstacle_count = 0
	obstacle_delay_max = 240
	obstacle_delay = obstacle_delay_max
	distance = 0
	pace = 1
	fdeath = 0
	endBonus = 0
	gliderdelaymax = 3
	gliderdelay = gliderdelaymax
	gliderstate = 1
	glidertrack = 1
	min = 0
	sec = 0
	fg1track = 0
	fg2track = 0
	bg1highscores = {}
	for i=1,5 do
		bg1highscores[i] = {}
		bg1highscores[i][1] = 0
		bg1highscores[i][2] = 0
		bg1highscores[i][3] = 0
		bg1highscores[i][4] = 0
	end
end

function unloadfunctions()
bg1saveHighscore = null
bg1loadHighscore = null
loadmg1intro = null
unloadmg1intro = null
mg1intro = null
loadgraphics = null
initGameEnvironment = null
moveBoundaries = null
gliderMotion = null
objects = null
difficultyCurve = null
deathAnim = null
animGlider = null
playBonus1 = null
start = null
collectgarbage()
end

function uninitGameEnvironment()
	displayTime = null
	playing = null
	glider = null
	obstacle_list = null
	block_width = null
	level_track = null
	scroll_speed = null
	obstacle_speed = null
	bg1difficulty = null
	gravity = null
	gravity_delay_max = null
	gravity_delay = null
	obstacle_count = null
	obstacle_delay_max = null
	obstacle_delay = null
	distance = null
	pace = null
	fdeath = null
	endBonus = null
	gliderdelaymax = null
	gliderdelay = null
	gliderstate = null
	glidertrack = null
	min = null
	sec = null
	fg1track = null
	fg2track = null
	bg1highscores = null
end

function moveBoundaries()
	fg1track = fg1track + 1
	if fg1track > 480 then
		fg1track = 1
	end
	fg2track = fg2track + 4
	if fg2track > 480 then
		fg2track = 1
	end
	
	screen:blit(0, 0, b1bg)
	screen:blit(0 - fg1track, 180, fg1)
	screen:blit(480 - fg1track,180, fg1)
	screen:blit(0 - fg2track,232, fg2)
	screen:blit(480 - fg2track,232, fg2)
end

function gliderMotion()
	gravity_delay = gravity_delay - 1

	pad = Controls.read()
	if pad:cross() then
		if gravity > -3 and gravity_delay <= 0 then
			gravity = gravity - 1
			gravity_delay = gravity_delay_max
		end
		if gliderdelay == 0 then
			gliderstate = gliderstate + glidertrack
			gliderdelay = gliderdelaymax
		else
			gliderdelay = gliderdelay - 1
		end
	else
		if gravity < 3 and gravity_delay <= 0 then
			gravity = gravity + 1
			gravity_delay = gravity_delay_max
		end
		gliderstate = 2
	end
	if pad:left() then
		if glider.x > 0 then
			glider.x = glider.x - 3
		end
	end
	if pad:right() then
		if glider.x < 420 then
			glider.x = glider.x + 3
		end
	end
	if pad:analogX() > 30 then 
		if glider.x < 420 then
			glider.x = glider.x + 3
		end
	end
	if pad:analogX() < -30 then 
		if glider.x > 0 then
			glider.x = glider.x - 3
		end
	end
	if pad:select() then
		screen:save("bonus1.png")
	end

	if glider.y + 30 + gravity > 10 and glider.y + gravity < 262 then
		glider.y = glider.y + gravity
	end
	
	if glider.y + 45 > 242 then
		deathAnim()
	end
end

function objects()
	obstacle_delay = obstacle_delay - 1
	if obstacle_delay <= 0 then
		obstacle_count = obstacle_count + 1
		place = math.random(0,180)
		otype = math.random(1,2)
		obstacle_list[obstacle_count] = {x = 480, y = place}
		if otype == 1 then
			obstacle_list[obstacle_count].image = obstacle1
			obstacle_list[obstacle_count].w = 50
			obstacle_list[obstacle_count].h = 50
		else
			obstacle_list[obstacle_count].image = obstacle2
			obstacle_list[obstacle_count].w = 30
			obstacle_list[obstacle_count].h = 30
		end
		obstacle_delay = obstacle_delay_max
	end
	for i=1, obstacle_count do
		obstacle_list[i].x = obstacle_list[i].x - obstacle_speed
		if obstacle_list[i].x < (0 - obstacle_list[i].w) then
			for j=i, obstacle_count-1 do
				obstacle_list[j] = obstacle_list[j+1]
			end
			obstacle_count = obstacle_count - 1
		end
		if obstacle_list[i].w == 30 then
			screen:blit(obstacle_list[i].x+20, obstacle_list[i].y+20, tail)
		end
		screen:blit(obstacle_list[i].x, obstacle_list[i].y, obstacle_list[i].image)
		if (glider.x + glider.w) > obstacle_list[i].x and (glider.x + glider.w) < (obstacle_list[i].x + obstacle_list[i].w) then
			if (glider.y + 35) > obstacle_list[i].y and (glider.y + 35) < (obstacle_list[i].y + obstacle_list[i].h) then
				deathAnim()
			elseif (glider.y + 50) > obstacle_list[i].y and (glider.y + 45) < (obstacle_list[i].y + obstacle_list[i].h) then
				deathAnim()
			end
		elseif glider.x > obstacle_list[i].x and glider.x < (obstacle_list[i].x + obstacle_list[i].w) then
			if (glider.y + 35) > obstacle_list[i].y and (glider.y + 35) < (obstacle_list[i].y + obstacle_list[i].h) then
				deathAnim()
			elseif (glider.y + 50) > obstacle_list[i].y and (glider.y + 50) < (obstacle_list[i].y + obstacle_list[i].h) then
				deathAnim()
			end
		end
	end
		
end

function difficultyCurve()
	distance = distance + 1
	if distance == 60 then
		sec = sec + 1
		if sec == 60 then
			min = min + 1
			sec = 0
		end
		distance = 0
	end
	check = ((min*60*60)+(sec*60)+distance)/bg1difficulty
	if check == pace then
		scroll_speed = scroll_speed + 1
		obstacle_speed = obstacle_speed + 1
		if obstacle_delay_max > 60 then
			obstacle_delay_max = obstacle_delay_max - 60
		end
		pace = pace + 1
	end
end

function deathAnim()
	finaldistance = distance
	block_h:play()
	exptrack1 = 1
	expx1 = math.random(0,50)
	expy1 = math.random(25,40)
	expdelay1 = 0

	exptrack2 = 3
	expx2 = math.random(0,50)
	expy2 = math.random(25,40)
	expdelay2 = 0

	exptrack3 = 2
	expx3 = math.random(0,50)
	expy3 = math.random(25,40)
	expdelay3 = 0
	for i=0, 120 do
		distance = distance + 1
		moveBoundaries()
		for i=1, obstacle_count do
			if obstacle_list[i].w == 30 then
				screen:blit(obstacle_list[i].x+20, obstacle_list[i].y+20, tail)
			end
			screen:blit(obstacle_list[i].x, obstacle_list[i].y, obstacle_list[i].image)
			obstacle_list[i].x = obstacle_list[i].x - 4
		end
		screen:blit(glider.x, glider.y, fd2)
		if expdelay1 == 0 then
			if exptrack1 == 1 then
				expimage1 = exp1
			end
			if exptrack1 == 2 then
				expimage1 = exp2
			end
			if exptrack1 == 3 then
				expimage1 = exp3
				exptrack1 = 1
				expx1 = math.random(0,50)
				expy1 = math.random(25,40)
			end
			expdelay1 = math.random(4,6)
			exptrack1 = exptrack1 + 1
		else
			expdelay1 = expdelay1 - 1
		end
		if expdelay2 == 0 then
			if exptrack2 == 1 then
				expimage2 = exp1
			end
			if exptrack2 == 2 then
				expimage2 = exp2
			end
			if exptrack2 == 3 then
				expimage2 = exp3
				exptrack2 = 1
				expx2 = math.random(0,50)
				expy2 = math.random(25,40)
			end
			expdelay2 = math.random(4,6)
			exptrack2 = exptrack2 + 1
		else
			expdelay2 = expdelay2 - 1
		end
		if expdelay3 == 0 then
			if exptrack3 == 1 then
				expimage3 = exp1
			end
			if exptrack3 == 2 then
				expimage3 = exp2
			end
			if exptrack3 == 3 then
				expimage3 = exp3
				exptrack3 = 1
				expx3 = math.random(0,50)
				expy3 = math.random(25,40)
			end
			expdelay3 = math.random(4,6)
			exptrack3 = exptrack3 + 1
		else
			expdelay3 = expdelay3 - 1
		end
		screen:blit(glider.x+expx1, glider.y+expy1, expimage1)
		screen:blit(glider.x+expx2, glider.y+expy2, expimage2)
		screen:blit(glider.x+expx3, glider.y+expy3, expimage3)
		glider.x = glider.x - 4
		screen.flip()
		screen.waitVblankStart(1)
	end
	fdeath = 1
end
	

function animGlider()
	if gliderstate == 1 then
		screen:blit(glider.x, glider.y, flier1)
		glidertrack = 1
		playing = 0
	elseif gliderstate == 2 then
		screen:blit(glider.x, glider.y, flier2)
	elseif gliderstate == 3 then
		screen:blit(glider.x, glider.y, flier3)
		glidertrack = -1
		if playing == 0 then
			flap:play()
			playing = 1
		end
	end
end

function playBonus1()
	initGameEnvironment()
	start()
	initGameEnvironment()
	while true do
		moveBoundaries()
		gliderMotion()
		objects()
		difficultyCurve()
		animGlider()
		screen:blit(155, 242, timer)
		screen:print(230, 252, min .. " Min " .. sec .. " Sec", black)
		screen.flip()
		screen.waitVblankStart(1)

		if fdeath == 1 then
			break
		end
	end
	if fdeath == 1 then
		Music.stop()
		sec1 = 0
		sec2 = 0
		while sec > 0 do
			sec2 = sec2 + 1
			if sec2 == 10 then
				sec2 = 0
				sec1 = sec1 + 1
			end
			sec = sec - 1
		end
		local n = 272
		bg1loadHighscore()
		for i = 1, 5 do
			if bg1highscores[i][2] == null then
				bg1highscores[i][2] = min
				bg1highscores[i][3] = sec1
				bg1highscores[i][4] = sec2
				enterhighscore(i, bg1highscores)
				bg1saveHighscore()
				break
			end
			if min > bg1highscores[i][2] then
				if i < 5 then
					j = 5
					while j > i do
						bg1highscores[j][1] = bg1highscores[j-1][1]
						bg1highscores[j][2] = bg1highscores[j-1][2]
						bg1highscores[j][3] = bg1highscores[j-1][3]
						bg1highscores[j][4] = bg1highscores[j-1][4]
						j = j - 1
					end
				end
				bg1highscores[i][2] = min
				bg1highscores[i][3] = sec1
				bg1highscores[i][4] = sec2
				enterhighscore(i, bg1highscores)
				bg1saveHighscore()
				break
			elseif min == bg1highscores[i][2] and sec1 > bg1highscores[i][3] then
				if i < 5 then
					j = 5
					while j > i do
						bg1highscores[j][1] = bg1highscores[j-1][1]
						bg1highscores[j][2] = bg1highscores[j-1][2]
						bg1highscores[j][3] = bg1highscores[j-1][3]
						bg1highscores[j][4] = bg1highscores[j-1][4]
						j = j - 1
					end
				end
				bg1highscores[i][2] = min
				bg1highscores[i][3] = sec1
				bg1highscores[i][4] = sec2
				enterhighscore(i, bg1highscores)
				bg1saveHighscore()
				break
			elseif min == bg1highscores[i][2] and sec1 == bg1highscores[i][3] and sec2 > bg1highscores[i][4] then
				if i < 5 then
					j = 5
					while j > i do
						bg1highscores[j][1] = bg1highscores[j-1][1]
						bg1highscores[j][2] = bg1highscores[j-1][2]
						bg1highscores[j][3] = bg1highscores[j-1][3]
						bg1highscores[j][4] = bg1highscores[j-1][4]
						j = j - 1
					end
				end
				bg1highscores[i][2] = min
				bg1highscores[i][3] = sec1
				bg1highscores[i][4] = sec2
				enterhighscore(i, bg1highscores)
				bg1saveHighscore()
				break
			end
		end
		while true do
			screen:blit(0, 0, b1scorebg)
			intprint(180, 146, min)
			intprint(240, 146, sec1)
			intprint(270, 146, sec2)
			screen:blit(0, n, option)
			screen.flip()
			screen.waitVblankStart(1)
			pad = Controls.read()
			if pad:cross() then
				break
			end
			if pad:circle() then
				endBonus = 1
				break
			end
			if n > 200 then
				n = n - 5
			end
			if pad:triangle() then
				while pad:triangle() do
					pad = Controls.read()
				end
				bg1loadHighscore()
				screen:clear()
				screen:blit(0,0,bg1hs)
				for i=1,5 do
					if bg1highscores[i][1] ~= null then
						printchar(100,45 + (i*25), string.sub(bg1highscores[i][1],1,1))
						printchar(125,45 + (i*25), string.sub(bg1highscores[i][1],2,2))
						printchar(150,45 + (i*25), string.sub(bg1highscores[i][1],3,3))
					end
					if bg1highscores[i][2] ~= null then
						intprint(200, 45 + (i*25), bg1highscores[i][2])
						screen:print(230, 50 + (i*25), "Min", white)
					end
					if bg1highscores[i][3] ~= null then
						intprint(260, 45 + (i*25), bg1highscores[i][3])
					end
					if bg1highscores[i][4] ~= null then
						intprint(285, 45 + (i*25), bg1highscores[i][4])
						screen:print(315, 50 + (i*25), "Sec", white)
					end
				end
				screen.flip()
				while true do
					pad = Controls.read()
					if pad:circle() then
						while pad:circle() do
							pad = Controls.read()
						end
						break
					end
					screen.waitVblankStart(1)
				end
			end
		end
		if displayTime > hi_score then
			hi_score = displayTime
		end
		fdeath = 0
		if endBonus == 0 then
			playBonus1()
		end
	end
end

function start()
	Music.playFile("sounds/0-fire.xm", true )
	local x = -70
	local y = -130
	distance = 0
	while distance < 120 do
		moveBoundaries()
		screen:blit(x, y, flier2)
		distance = distance + 1
		screen.flip()
		screen.waitVblankStart(1)
		if y < 50 then
			y = y + 1
		end
		if distance == 2 and x < 20 then
			x = x + 1
			distance = 0
		end
	end
	distance = 0
end

-------------------------------main-------------------------------
hi_score = 0
mg1intro()
loadgraphics()
playBonus1()
Music.stop()
unloadgraphics()
unloadfunctions()